from cml.usecases.usecase import Usecase
from cml.domain import (
    Preprocessor,
    DataSource,
    LearnblockIdentifier,
    Constructor
)


class PreprocessUsecase(Usecase):
    def process(self, request):
        preprocesser = Preprocessor(request.pre_settings)
        cleaned_data = preprocesser.clean(request.source_adapter)
        learnblock_identifier = LearnblockIdentifier(request.block_settings)
        data_source = DataSource(cleaned_data,
                                 learnblock_identifier,
                                 block_size=request.block_settings.block_size)
        return data_source


class CreateConstructorUsecase(Usecase):
    def process(self, request):
        return Constructor(request.ml_models, request.settings)


class KnowledgeSearchUsecase(Usecase):
    def process(self, request):
        pass
